/** @file PCI3120_LabVIEW.h
 *
 *  @author  L. Sartory
 *  @date    Creation: 16.10.2014
 *  @date    $LastChangedDate$
 *  @version $LastChangedRevision$
 *
 *  @par DESCRIPTION
 *  xPCI3120 LabVIEW header file
 *
 *  @par LICENCE
 *  @verbatim
 *  Copyright (C) 2014 ADDI-DATA GmbH
 *
 *  ADDI-DATA GmbH
 *  Airpark Business Center
 *  Airport Boulevard B210
 *  77836 Rheinmnster
 *  Germany
 *  Tel: +49(0)7229/1847-0    |  Fax: +49(0)7229/1847-200
 *  http://www.addi-data-com  |  info@addi-data.com
 *  @endverbatim
 **/

short int __stdcall i_PCI3120_GetNumberOfBoards(unsigned __int8 *nbrOfBoards);
short int __stdcall i_PCI3120_GetBoardInformation(unsigned __int8 boardIndex, unsigned long int identifierStringSize, char *identifier, unsigned long int *UINumber, unsigned long int *deviceNumber, unsigned long int *busNumber, unsigned long int *baseAddress0, unsigned long int *baseAddress1, unsigned long int *baseAddress2, unsigned long int *version, unsigned __int8 *interrupt);
short int __stdcall i_PCI3120_OpenBoardViaIndex(unsigned __int8 boardIndex, unsigned long int *deviceHandle);
short int __stdcall i_PCI3120_OpenBoardViaIdentifier(PCHAR identifier, unsigned long int *deviceHandle);
short int __stdcall i_PCI3120_CloseBoard(unsigned long int deviceHandle);
short int __stdcall i_PCI3120_GetDLLVersion(unsigned long int *version);
short int __stdcall i_PCI3120_GetDeviceDriverVersion(unsigned long int deviceHandle, unsigned long int *version);

short int __stdcall i_PCI3120_SetLabViewInterrupt(unsigned long int deviceHandle, LVUserEventRef *LabViewEventRef);
short int __stdcall i_PCI3120_ResetLabViewInterrupt(unsigned long int deviceHandle);

short int __stdcall i_PCI3120_SetDigitalOutputMemoryOn(unsigned long int deviceHandle);
short int __stdcall i_PCI3120_SetDigitalOutputMemoryOff(unsigned long int deviceHandle);
short int __stdcall i_PCI3120_Read1DigitalInput(unsigned long int deviceHandle, unsigned __int8 channel, unsigned __int8 *value);
short int __stdcall i_PCI3120_Read4DigitalInputs(unsigned long int deviceHandle, unsigned __int8 *value);
short int __stdcall i_PCI3120_Set1DigitalOutputOn(unsigned long int deviceHandle, unsigned __int8 channel);
short int __stdcall i_PCI3120_Set1DigitalOutputOff(unsigned long int deviceHandle, unsigned __int8 channel);
short int __stdcall i_PCI3120_Set4DigitalOutputsOn(unsigned long int deviceHandle, unsigned __int8 mask);
short int __stdcall i_PCI3120_Set4DigitalOutputsOff(unsigned long int deviceHandle, unsigned __int8 mask);
short int __stdcall i_PCI3120_Get1DigitalOutputStatus(unsigned long int deviceHandle, unsigned __int8 channel, unsigned __int8 *outputsStatus);
short int __stdcall i_PCI3120_Get4DigitalOutputsStatus(unsigned long int deviceHandle, unsigned __int8 *outputsStatus);

short int __stdcall i_PCI3120_SetAnalogInputMode(unsigned long int deviceHandle, unsigned __int8 inputMode);
short int __stdcall i_PCI3120_GetAnalogInputMode(unsigned long int deviceHandle, unsigned __int8 *inputMode);
short int __stdcall i_PCI3120_Read1AnalogInput(unsigned long int deviceHandle, unsigned __int8 channel, unsigned __int8 gain, unsigned __int8 polarity, unsigned short int convertingTime, unsigned __int8 interruptFlag, unsigned short int *channelValue);
short int __stdcall i_PCI3120_ReadMoreAnalogInputs(unsigned long int deviceHandle, unsigned __int8 channelCount, unsigned __int8 *channel, unsigned __int8 *gain, unsigned __int8 *polarity, unsigned short int convertingTime, unsigned __int8 interruptFlag, unsigned short int *channelValue);

short int __stdcall i_PCI3120_Write1AnalogOutput(unsigned long int deviceHandle, unsigned __int8 channel, unsigned __int8 polarity, unsigned short int value);
short int __stdcall i_PCI3120_WriteMoreAnalogOutputs(unsigned long int deviceHandle, unsigned __int8 channelNbr, unsigned __int8 *channels, unsigned __int8 *polarity, unsigned short int *value);

short int __stdcall i_PCI3120_InitAndStartAnalogInputSequence(unsigned long int deviceHandle, unsigned long int sequenceCount, unsigned long int sequenceBeforeInterrupt, unsigned __int8 channelCount, unsigned __int8 *channel, unsigned __int8 *gain, unsigned __int8 *polarity, unsigned short int convertingTime, unsigned __int8 delayMode, unsigned long int delayTime, unsigned __int8 extTriggerMode);
short int __stdcall i_PCI3120_StopAnalogAcquisition(unsigned long int deviceHandle);
long  int __stdcall l_PCI3120_ReadSequenceData(unsigned long int deviceHandle, unsigned long int size, void *data);

short int __stdcall i_PCI3120_InitAndStartTimerWatchdog(unsigned long int deviceHandle, unsigned __int8 timerMode, unsigned long int delayValue, unsigned __int8 interruptFlag);
short int __stdcall i_PCI3120_StopTimerWatchdog(unsigned long int deviceHandle);
short int __stdcall i_PCI3120_ReadWatchdogStatus(unsigned long int deviceHandle, unsigned __int8 *watchdogStatus);
short int __stdcall i_PCI3120_ReadTimerValue(unsigned long int deviceHandle, unsigned long int *readValue);
short int __stdcall i_PCI3120_WriteTimerValue(unsigned long int deviceHandle, unsigned long int writeValue);
