#ifndef __PCI3120_DEFINE_H
#define __PCI3120_DEFINE_H
	
enum {
	APCI3120_CHANNEL_0,
	APCI3120_CHANNEL_1,
	APCI3120_CHANNEL_2,
	APCI3120_CHANNEL_3,
	APCI3120_CHANNEL_4,
	APCI3120_CHANNEL_5,
	APCI3120_CHANNEL_6,
	APCI3120_CHANNEL_7,
	APCI3120_CHANNEL_8,
	APCI3120_CHANNEL_9,
	APCI3120_CHANNEL_10,
	APCI3120_CHANNEL_11,
	APCI3120_CHANNEL_12,
	APCI3120_CHANNEL_13,
	APCI3120_CHANNEL_14,
	APCI3120_CHANNEL_15
};

/* Digital input/output related */
#define	PCI3120_DIGITAL_INPUT_NUMBER			4
#define	PCI3120_DIGITAL_OUTPUT_NUMBER			4

/* Analog output related */
#define	PCI3120_ANALOG_OUTPUT_NUMBER			8

/* Analog input related */
#define	PCI3120_ANALOG_INPUT_NUMBER				16

/* Analog input mode related */
#define PCI3120_INPUT_MODE_UNDEFINED	0x0
#define PCI3120_INPUT_MODE_SINGLE_ENDED	0x1
#define PCI3120_INPUT_MODE_DIFFERENTIAL	0x2

#define APCI3120_DISABLE		0
#define APCI3120_ENABLE			1

#define PCI3120_GAIN_1			0
#define PCI3120_GAIN_2			1
#define PCI3120_GAIN_5			2
#define PCI3120_GAIN_10		3

#define APCI3120_BIPOLAR		0
#define APCI3120_UNIPOLAR		1

#define APCI3120_SIMPLE_MODUS	30	
#define APCI3120_DELAY_MODUS	31
#define APCI3120_DELAY_1_MODUS	32

#define APCI3120_SINGLE			40
#define APCI3120_CONTINUOUS		41

#define APCI3120_DMA_NOT_USED	50
#define APCI3120_DMA_USED		51

#define APCI3120_TIMER			60
#define APCI3120_WATCHDOG		61

#endif