UNIT PCI3120;

INTERFACE

CONST
	APCI3120_CHANNEL_0 = 0;
	APCI3120_CHANNEL_1 = 1;
	APCI3120_CHANNEL_2 = 2;
	APCI3120_CHANNEL_3 = 3;
	APCI3120_CHANNEL_4 = 4;
	APCI3120_CHANNEL_5 = 5;
	APCI3120_CHANNEL_6 = 6;
	APCI3120_CHANNEL_7 = 7;
	APCI3120_CHANNEL_8 = 8;
	APCI3120_CHANNEL_9 = 9;
	APCI3120_CHANNEL_10 = 10;
	APCI3120_CHANNEL_11 = 11;
	APCI3120_CHANNEL_12 = 12;
	APCI3120_CHANNEL_13 = 13;
	APCI3120_CHANNEL_14 = 14;
	APCI3120_CHANNEL_15 = 15;

  PCI3120_DIGITAL_INPUT_NUMBER	 =		4;
  PCI3120_DIGITAL_OUTPUT_NUMBER	 =		4;

  PCI3120_ANALOG_OUTPUT_NUMBER	 =		8;

  PCI3120_ANALOG_INPUT_NUMBER		 =		16;

  PCI3120_INPUT_MODE_UNDEFINED	= $0;
  PCI3120_INPUT_MODE_SINGLE_ENDED	= $1;
  PCI3120_INPUT_MODE_DIFFERENTIAL	= $2;

  APCI3120_DISABLE	=	0;
  APCI3120_ENABLE		=	1;

  PCI3120_GAIN_1		=	0;
  PCI3120_GAIN_2		=	1;
  PCI3120_GAIN_5		=	2;
  PCI3120_GAIN_10		= 3;

  APCI3120_BIPOLAR	=	0;
  APCI3120_UNIPOLAR	=	1;

  APCI3120_SIMPLE_MODUS	= 30;
  APCI3120_DELAY_MODUS	= 31;
  APCI3120_DELAY_1_MODUS = 32;

  APCI3120_SINGLE		 =	40;
  APCI3120_CONTINUOUS	 =	41;

  APCI3120_DMA_NOT_USED	= 50;
  APCI3120_DMA_USED		= 51;

  APCI3120_TIMER		=	60;
  APCI3120_WATCHDOG	=	61;

type INT16 = SmallInt;

FUNCTION i_PCI3120_GetNumberOfBoards(var pb_NbrOfBoards : Byte): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_GetBoardInformation(b_BoardIndex : Byte;
                                       dw_IdentifierStringSize : LongWord;
                                       pc_Identifier : PAnsiChar;
                                       var pdw_UINumber : LongWord;
                                       var pdw_DeviceNumber : LongWord;
                                       var pdw_BusNumber : LongWord;
                                       var pdw_BaseAddress0 : LongWord;
                                       var pdw_BaseAddress1 : LongWord;
                                       var pdw_BaseAddress2 : LongWord;
                                       var pdw_Version : LongWord;
                                       var pb_Interrupt : Byte): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_OpenBoardViaIndex(b_BoardIndex : Byte;
                                     var ph_DeviceHandle : THANDLE): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_OpenBoardViaIdentifier(pc_Identifier : PCHAR;
                                          var ph_DeviceHandle : THANDLE): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_CloseBoard(h_DeviceHandle : THANDLE): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_GetDLLVersion(var pdw_Version : LongWord): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_GetDeviceDriverVersion(h_DeviceHandle : THANDLE; var pdw_Version : LongWord): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_SetBoardIntRoutine(h_DeviceHandle : THANDLE;
                                      v_FunctionName : Pointer): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_ResetBoardIntRoutine(h_DeviceHandle : THANDLE): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_SetDigitalOutputMemoryOn(h_DeviceHandle : THANDLE): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_SetDigitalOutputMemoryOff(h_DeviceHandle : THANDLE): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_Read1DigitalInput(h_DeviceHandle : THANDLE;
                                     b_Channel : Byte;
                                     var pb_Value : Byte): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_Read4DigitalInputs(h_DeviceHandle : THANDLE;
                                      var pb_Value : Byte): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_Set1DigitalOutputOn(h_DeviceHandle : THANDLE;
                                       b_Channel : Byte): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_Set1DigitalOutputOff(h_DeviceHandle : THANDLE;
                                        b_Channel : Byte): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_Set4DigitalOutputsOn(h_DeviceHandle : THANDLE;
                                        b_Mask : Byte): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_Set4DigitalOutputsOff(h_DeviceHandle : THANDLE;
                                         b_Mask : Byte): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_Get1DigitalOutputStatus(h_DeviceHandle : THANDLE;
                                           b_Channel : Byte;
                                           var pb_OutputsStatus : Byte): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_Get4DigitalOutputsStatus(h_DeviceHandle : THANDLE;
                                            var pb_OutputsStatus : Byte): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_SetAnalogInputMode(h_DeviceHandle : THANDLE;
                                      b_InputMode : Byte): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_GetAnalogInputMode(h_DeviceHandle : THANDLE;
                                      var pb_InputMode : Byte): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_Read1AnalogInput(h_DeviceHandle : THANDLE;
                                    b_Channel : Byte;
                                    b_Gain : Byte;
                                    b_Polarity : Byte;
                                    w_ConvertingTime : Word;
                                    b_InterruptFlag : Byte;
                                    var pw_ChannelValue : Word): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_ReadMoreAnalogInputs(h_DeviceHandle : THANDLE;
                                        b_ChannelCount : Byte;
                                        var pb_Channel : Byte;
                                        var pb_Gain : Byte;
                                        var pb_Polarity : Byte;
                                        w_ConvertingTime : Word;
                                        b_InterruptFlag : Byte;
                                        var pw_ChannelValue : Word): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_Write1AnalogOutput(h_DeviceHandle : THANDLE;
                                      b_Channel : Byte;
                                      b_Polarity : Byte;
                                      w_Value : Word): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_WriteMoreAnalogOutputs(h_DeviceHandle : THANDLE;
                                          b_ChannelNbr : Byte;
                                          var pb_Channels : Byte;
                                          var pb_Polarity : Byte;
                                          var pw_Value : Word): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_InitAndStartAnalogInputSequence(h_DeviceHandle : THANDLE;
                                                   dw_SequenceCount : LongWord;
                                                   dw_SequenceBeforeInterrupt : LongWord;
                                                   b_ChannelCount : Byte;
                                                   var pb_Channel : Byte;
                                                   var pb_Gain : Byte;
                                                   var pb_Polarity : Byte;
                                                   w_ConvertingTime : Word;
                                                   b_DelayMode : Byte;
                                                   dw_DelayTime : LongWord;
                                                   b_ExtTriggerMode : Byte): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_StopAnalogAcquisition(h_DeviceHandle : THANDLE): Int16;FAR;STDCALL;

FUNCTION l_PCI3120_ReadSequenceData(h_DeviceHandle : THANDLE; size : LongWord; data : Pointer): Int64;FAR;STDCALL;

FUNCTION i_PCI3120_InitAndStartTimerWatchdog(h_DeviceHandle : THANDLE;
                                             b_TimerMode : Byte;
                                             dw_DelayValue : LongWord;
                                             b_InterruptFlag : Byte): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_StopTimerWatchdog(h_DeviceHandle : THANDLE): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_ReadWatchdogStatus(h_DeviceHandle : THANDLE; var pb_WatchdogStatus : Byte): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_ReadTimerValue(h_DeviceHandle : THANDLE; var pdw_ReadValue : LongWord): Int16;FAR;STDCALL;

FUNCTION i_PCI3120_WriteTimerValue(h_DeviceHandle : THANDLE; dw_WriteValue : LongWord): Int16;FAR;STDCALL;



IMPLEMENTATION



FUNCTION i_PCI3120_GetNumberOfBoards(var pb_NbrOfBoards : Byte): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_GetBoardInformation(b_BoardIndex : Byte;
                                       dw_IdentifierStringSize : LongWord;
                                       pc_Identifier : PAnsiChar;
                                       var pdw_UINumber : LongWord;
                                       var pdw_DeviceNumber : LongWord;
                                       var pdw_BusNumber : LongWord;
                                       var pdw_BaseAddress0 : LongWord;
                                       var pdw_BaseAddress1 : LongWord;
                                       var pdw_BaseAddress2 : LongWord;
                                       var pdw_Version : LongWord;
                                       var pb_Interrupt : Byte): Int16;FAR;STDCALL;External 'PCI3120.DLL';
									   
FUNCTION i_PCI3120_OpenBoardViaIndex(b_BoardIndex : Byte;
                                     var ph_DeviceHandle : THANDLE): Int16;FAR;STDCALL;External 'PCI3120.DLL';


FUNCTION i_PCI3120_OpenBoardViaIdentifier(pc_Identifier : PCHAR;
                                          var ph_DeviceHandle : THANDLE): Int16;FAR;STDCALL;External 'PCI3120.DLL';


FUNCTION i_PCI3120_CloseBoard(h_DeviceHandle : THANDLE): Int16;FAR;STDCALL;External 'PCI3120.DLL';


FUNCTION i_PCI3120_GetDLLVersion(var pdw_Version : LongWord): Int16;FAR;STDCALL;External 'PCI3120.DLL';


FUNCTION i_PCI3120_GetDeviceDriverVersion(h_DeviceHandle : THANDLE; var pdw_Version : LongWord): Int16;FAR;STDCALL;External 'PCI3120.DLL';


FUNCTION i_PCI3120_SetBoardIntRoutine(h_DeviceHandle : THANDLE;
                                      v_FunctionName : Pointer): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_ResetBoardIntRoutine(h_DeviceHandle : THANDLE): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_SetDigitalOutputMemoryOn(h_DeviceHandle : THANDLE): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_SetDigitalOutputMemoryOff(h_DeviceHandle : THANDLE): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_Read1DigitalInput(h_DeviceHandle : THANDLE;
                                     b_Channel : Byte;
                                     var pb_Value : Byte): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_Read4DigitalInputs(h_DeviceHandle : THANDLE;
                                      var pb_Value : Byte): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_Set1DigitalOutputOn(h_DeviceHandle : THANDLE;
                                       b_Channel : Byte): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_Set1DigitalOutputOff(h_DeviceHandle : THANDLE;
                                        b_Channel : Byte): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_Set4DigitalOutputsOn(h_DeviceHandle : THANDLE;
                                        b_Mask : Byte): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_Set4DigitalOutputsOff(h_DeviceHandle : THANDLE;
                                         b_Mask : Byte): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_Get1DigitalOutputStatus(h_DeviceHandle : THANDLE;
                                           b_Channel : Byte;
                                           var pb_OutputsStatus : Byte): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_Get4DigitalOutputsStatus(h_DeviceHandle : THANDLE;
                                            var pb_OutputsStatus : Byte): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_SetAnalogInputMode(h_DeviceHandle : THANDLE;
                                      b_InputMode : Byte): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_GetAnalogInputMode(h_DeviceHandle : THANDLE;
                                      var pb_InputMode : Byte): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_Read1AnalogInput(h_DeviceHandle : THANDLE;
                                    b_Channel : Byte;
                                    b_Gain : Byte;
                                    b_Polarity : Byte;
                                    w_ConvertingTime : Word;
                                    b_InterruptFlag : Byte;
                                    var pw_ChannelValue : Word): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_ReadMoreAnalogInputs(h_DeviceHandle : THANDLE;
                                        b_ChannelCount : Byte;
                                        var pb_Channel : Byte;
                                        var pb_Gain : Byte;
                                        var pb_Polarity : Byte;
                                        w_ConvertingTime : Word;
                                        b_InterruptFlag : Byte;
                                        var pw_ChannelValue : Word): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_Write1AnalogOutput(h_DeviceHandle : THANDLE;
                                      b_Channel : Byte;
                                      b_Polarity : Byte;
                                      w_Value : Word): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_WriteMoreAnalogOutputs(h_DeviceHandle : THANDLE;
                                          b_ChannelNbr : Byte;
                                          var pb_Channels : Byte;
                                          var pb_Polarity : Byte;
                                          var pw_Value : Word): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_InitAndStartAnalogInputSequence(h_DeviceHandle : THANDLE;
                                                   dw_SequenceCount : LongWord;
                                                   dw_SequenceBeforeInterrupt : LongWord;
                                                   b_ChannelCount : Byte;
                                                   var pb_Channel : Byte;
                                                   var pb_Gain : Byte;
                                                   var pb_Polarity : Byte;
                                                   w_ConvertingTime : Word;
                                                   b_DelayMode : Byte;
                                                   dw_DelayTime : LongWord;
                                                   b_ExtTriggerMode : Byte): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_StopAnalogAcquisition(h_DeviceHandle : THANDLE): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION l_PCI3120_ReadSequenceData(h_DeviceHandle : THANDLE; size : LongWord; data : Pointer): Int64;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_InitAndStartTimerWatchdog(h_DeviceHandle : THANDLE;
                                             b_TimerMode : Byte;
                                             dw_DelayValue : LongWord;
                                             b_InterruptFlag : Byte): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_StopTimerWatchdog(h_DeviceHandle : THANDLE): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_ReadWatchdogStatus(h_DeviceHandle : THANDLE; var pb_WatchdogStatus : Byte): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_ReadTimerValue(h_DeviceHandle : THANDLE; var pdw_ReadValue : LongWord): Int16;FAR;STDCALL;External 'PCI3120.DLL';

FUNCTION i_PCI3120_WriteTimerValue(h_DeviceHandle : THANDLE; dw_WriteValue : LongWord): Int16;FAR;STDCALL;External 'PCI3120.DLL';

END.

