unit ConsoleCrt;


Interface

uses
  Classes, Windows, OleServer, Excel97, StdCtrls, ActiveX, Variants, Sysutils, ComObj;

Procedure ConsoleCrtInit;
Function  WhereX: Integer;
Function  WhereY: Integer;
Procedure WhereXY (Var X: Integer; Var Y : Integer);
Procedure ClrScr;
Procedure GotoXY(const x,y:Integer);
Procedure Delay(const ms:Integer);
Function  KeyPressed:boolean;
Function  ReadKey:Char;
Procedure ScrollConsole (i_StartPosition : Integer; i_ScrollValue   : Integer);
Procedure PrintThread (i_StartPosition : Integer; c_Text : String; Args : Array of Const);
Function  Pow2 (w_Exponent : Word):DWord;
Function  MemCmp(P1, P2: Pointer; Length: Integer): Integer; assembler;
Procedure MemCpy(P1, P2: Pointer; Length: DWord);
Function ExcelInstalled:Bool;
Function ConvertToExcel (s_SrcFileName                : String;
			 s_DesFileName                : String;
			 dw_NumberOfChannels          : DWord;
			 dw_NumberOfAcquisitions      : DWord;
                         dw_MaxNumberForEachWorksheet : DWord;
			 bo_ShowExcel                 : Bool) : Integer;

Var
  HConsoleInput:THandle;
  HConsoleOutput:THandle;
  WindMin:tcoord;
  WindMax:tcoord;
  w_TextAttr : Word;

Implementation

Procedure ClrScr;
   Var
     tc  : tcoord;
     nw  : DWord;
     cbi : TConsoleScreenBufferInfo;

   Begin
      getConsoleScreenBufferInfo(HConsoleOutput,cbi);
      tc.x := 0;
      tc.y := 0;
      FillConsoleOutputAttribute(HConsoleOutput,w_TextAttr,cbi.dwsize.x*cbi.dwsize.y,tc,nw);
      FillConsoleOutputCharacter(HConsoleOutput,#32,cbi.dwsize.x*cbi.dwsize.y,tc,nw);
      setConsoleCursorPosition(hconsoleoutput,tc);
   End;

Function WhereX: integer;
   Var
      cbi : TConsoleScreenBufferInfo;

   Begin
      getConsoleScreenBufferInfo(HConsoleOutput,cbi);
      result := tcoord(cbi.dwCursorPosition).x
   End;

Function WhereY: integer;
   Var
      cbi : TConsoleScreenBufferInfo;

   Begin
      getConsoleScreenBufferInfo(HConsoleOutput,cbi);
      result := tcoord(cbi.dwCursorPosition).y
   End;

Procedure WhereXY (Var X: Integer; Var Y : Integer);
   Var
      cbi : TConsoleScreenBufferInfo;

   Begin
      getConsoleScreenBufferInfo(HConsoleOutput,cbi);
      X := tcoord(cbi.dwCursorPosition).x;
      Y := tcoord(cbi.dwCursorPosition).y;
   End;


Procedure GotoXY(const x,y:integer);
   Var
      coord :tcoord;

   Begin
      coord.x := x;
      coord.y := y;
      setConsoleCursorPosition(hconsoleoutput,coord);
   End;

Function KeyPressed:boolean;
   Var
      dw_NumberOfEvents:DWord;

   Begin
      GetNumberOfConsoleInputEvents(hconsoleinput,dw_NumberOfEvents);
      result := dw_NumberOfEvents > 0;
   End;

Function ReadKey: Char;
   Var
      w_NumRead: DWord;
      InputRec : TInputRecord;

   Begin
      InputRec.EventType := 0;
      w_NumRead := 0;
      InputRec.Event.KeyEvent.bKeyDown := false;
      while ((Not ReadConsoleInput(HConsoleInput,InputRec,1,w_NumRead)) Or (InputRec.Event.KeyEvent.bKeyDown = false)) do;
      Result := InputRec.Event.KeyEvent.AsciiChar;
   End;

Procedure Delay (const ms:integer);
   Begin
      Sleep(ms);
   End;

Procedure ConsoleCrtInit;
   Var
      cbi : TConsoleScreenBufferInfo;

   Begin
      CoInitialize (Nil);
      SetActiveWindow(0);
      HConsoleInput  := GetStdHandle(STD_INPUT_HANDLE);
      HConsoleOutput := GetStdHandle(STD_OUTPUT_HANDLE);
      FlushConsoleInputBuffer (HConsoleInput);
      If getConsoleScreenBufferInfo(HConsoleOutput,cbi) Then
         Begin
         w_TextAttr := cbi.wAttributes;
         End
   End;

Procedure   ScrollConsole (i_StartPosition : Integer;
			   i_ScrollValue   : Integer);
Var
   (************************)
   (* Variable declaration *)
   (************************)
   srctReadRect  : SMALL_RECT;
   srctWriteRect : SMALL_RECT;
   p_chiBuffer   : ^CHAR_INFO;
   coordBufSize  : COORD;
   coordBufCoord : COORD;
   csbi          : CONSOLE_SCREEN_BUFFER_INFO;
Begin

  p_chiBuffer:= nil;

  (****************************************************)
  (* Get the current cursor position and the max X, Y *)
  (****************************************************)
  GetConsoleScreenBufferInfo (HConsoleOutput, csbi);

  (*****************************************)
  (* Read console buffer memory allocation *)
  (*****************************************)
  GetMem (p_chiBuffer, csbi.dwMaximumWindowSize.X * csbi.dwMaximumWindowSize.Y * sizeof (CHAR_INFO));

  If (p_chiBuffer <> nil) Then
     Begin
     FillChar (p_chiBuffer^, csbi.dwMaximumWindowSize.X * csbi.dwMaximumWindowSize.Y * sizeof (CHAR_INFO), 0);

     (****************************)
     (* Set the source rectangle *)
     (****************************)
     srctReadRect.Top    := i_StartPosition + i_ScrollValue - 1;
     srctReadRect.Left   := 0;
     srctReadRect.Bottom := csbi.dwMaximumWindowSize.Y - 1;
     srctReadRect.Right  := csbi.dwMaximumWindowSize.X;

     (**********************************)
     (* Set the size of buffer to copy *)
     (**********************************)
     coordBufSize.Y := csbi.dwMaximumWindowSize.Y - i_StartPosition - 1;
     coordBufSize.X := csbi.dwMaximumWindowSize.X;

     (************************************************************************)
     (*The top left destination cell of the temporary buffer is row 0, col 0 *)
     (************************************************************************)
     coordBufCoord.X := 0;
     coordBufCoord.Y := 0;

     (*************************************************************)
     (* Copy the block from the screen buffer to the temp. buffer *)
     (*************************************************************)
     If (ReadConsoleOutput(HConsoleOutput,
                           p_chiBuffer,
                           coordBufSize,
                           coordBufCoord,
                           srctReadRect)) Then
        Begin
        (*********************************)
        (* Set the destination rectangle *)
        (*********************************)
        srctWriteRect.Top     := i_StartPosition;
        srctWriteRect.Left    := 0;
        srctWriteRect.Bottom  := csbi.dwMaximumWindowSize.Y - 1;
	srctWriteRect.Right   := csbi.dwMaximumWindowSize.X - 1;

        (***********************************************************)
	(* Copy from the temporary buffer to the new screen buffer *)
        (***********************************************************)
        WriteConsoleOutput(HConsoleOutput,
                           p_chiBuffer,
                           coordBufSize,
                           coordBufCoord,
                           srctWriteRect);
        End;

     FreeMem (p_chiBuffer);
     End;
  End;


Procedure PrintThread (i_StartPosition : Integer; c_Text : String; Args : Array of Const);
	Var
	   (************************)
	   (* Variable declaration *)
	   (************************)
	   c_StringOut  : String;
	   i_LineCpt    : Integer;
	   i_X          : Integer;
	   i_Y          : Integer;
	   i_InsertLine : Integer;
	   w_Cpt        : Word;
	   csbi         : CONSOLE_SCREEN_BUFFER_INFO;

	Begin
	   (****************************************)
	   (* Get the argument and format the text *)
	   (****************************************)
	   c_StringOut := Format (c_Text, Args);
           i_LineCpt   := 0;

	   (****************************************************)
	   (* Get the current cursor position and the max X, Y *)
	   (****************************************************)
	   GetConsoleScreenBufferInfo (HConsoleOutput, csbi);
	   csbi.dwMaximumWindowSize.Y := csbi.dwMaximumWindowSize.Y - 1;

	   (************************)
	   (* Get the number of \n *)
	   (************************)
	   For w_Cpt := 1 To Length (c_StringOut) Do
	      Begin
	      If (c_StringOut [w_Cpt] = Chr (13)) Then
		 Begin
		 i_LineCpt := i_LineCpt + 1;
		 End;
	      End;

	   (******************************)
	   (* Test if any line to insert *)
	   (******************************)
	   If ((csbi.dwCursorPosition.Y + i_LineCpt) >= csbi.dwMaximumWindowSize.Y) Then
	      Begin
	      WhereXY (i_X, i_Y);
	      i_InsertLine := csbi.dwCursorPosition.Y + i_LineCpt - csbi.dwMaximumWindowSize.Y + 1;

	      (**********************)
	      (* Scroll the console *)
	      (**********************)
	      ScrollConsole (i_StartPosition, i_InsertLine + 1);

	      GotoXY (i_X, i_Y - i_InsertLine);
	      End;
	   Write (c_StringOut);
	End;

Function  Pow2 (w_Exponent : Word):DWord;
	Var
	   w_Cpt     : Word;
	   dw_Result : Dword;

	Begin
	   If (w_Exponent = 0) Then
	      dw_Result := 1
	   Else
	      Begin
	      dw_Result := 1;
	      For w_Cpt := 0 To (w_Exponent - 1) Do
		 dw_Result := dw_Result * 2;
	      End;

	Pow2 := dw_Result;
	End;

Function MemCmp(P1, P2: Pointer; Length: Integer): Integer; assembler;
asm
     push    esi
     push    edi
     mov     esi, P1
     mov     edi, P2
     mov     edx, ecx
     xor     eax, eax
     shr     ecx, 2
     repe    cmpsd
     jne     @@1
     and     edx, 3
     mov     ecx, edx
     repe    cmpsb
     jne     @@1
     jmp     @@3
@@1: ja      @@2
     dec     eax
     jmp     @@3
@@2: inc     eax
@@3: pop     edi
     pop     esi
end;

Procedure MemCpy(P1, P2: Pointer; Length: DWord);
   Begin
      Move (P2^, P1^, Length);
   End;


Function ExcelInstalled:Bool;
   Var
      App          : OleVariant;
      bo_Installed : Bool;
   Begin
      bo_Installed := True;
      Try
      App := CreateOleObject ('Excel.Application');
      App.Quit;
      Except
      On E: Exception do
         begin
         bo_Installed := False;
         End;
      End;

      ExcelInstalled := bo_Installed;
   End;

Function ConvertToExcel (s_SrcFileName                : String;
			 s_DesFileName                : String;
			 dw_NumberOfChannels          : DWord;
			 dw_NumberOfAcquisitions      : DWord;
                         dw_MaxNumberForEachWorksheet : DWord;
			 bo_ShowExcel                 : Bool) : Integer;
	Var
	   s_Range                : String;
	   s_Formula              : String;
	   s_Header               : String;
	   s_ReadString           : String;
	   s_TmpFileName          : String;
	   s_SrcFilePath          : String;
	   s_DesFilePath          : String;
	   s_TmpFilePath          : String;
           s_CountIf              : String;
	   c_Wait                 : Array [0..3] Of Char;
           c_Selection            : Array [0..1] Of String;
           s_Channel              : Array [0..31] Of String;
           s_SearchFormula        : Array [0..1000, 0..31] Of String;
           d_Min                  : Array [0..31] Of Double;
           d_Max                  : Array [0..31] Of Double;
           d_MinWorksheet         : Array [0..1000, 0..31] Of Double;
           d_MaxWorksheet         : Array [0..1000, 0..31] Of Double;
           dw_NbrOfLinesWorksheet : Array [0..1000] Of DWord;
           d_Average              : Array [0..31] Of Double;
           bo_OK                  : Bool;
           b_Choice               : Byte;
	   i_LCID                 : integer;
	   w_Wait                 : Word;
	   t_ExcelApplication     : TExcelApplication;
	   t_ExcelWorkbook        : TExcelWorkbook;
	   t_ExcelWorksheet       : TExcelWorksheet;
	   t_ExcelChart           : TExcelChart;
	   DataSheet              : _Worksheet;
	   Rnge                   : OleVariant;
           ChObj                  : ChartObject;
	   t_HandleTmp            : TextFile;
	   t_HandleInput          : TextFile;
	   dw_Cpt                 : DWord;
           dw_Test                : DWord;
           dw_FoundCpt            : DWord;
           dw_NbrOfLines          : DWord;
           dw_NbrOfAcquisition    : DWord;
	   dw_ReadLineCpt         : DWord;
	   dw_WorksheetCounter    : DWord;
           dw_NbrOfWorksheet      : DWord;
           d_TestValue            : Double;
           c_CountryCode          : Array [0..10] Of Char;

	Begin
           For dw_Cpt := 0 To 31 Do
              Begin
              d_Min     [dw_Cpt] := 100;
              d_Max     [dw_Cpt] := -100;
              d_Average [dw_Cpt] := 0;
              End;

           i_LCID := GetUserDefaultLCID;
           bo_OK  := False;
	   c_Wait [0]      := '|';
	   c_Wait [1]      := '/';
	   c_Wait [2]      := '-';
	   c_Wait [3]      := '\';
           w_Wait          := 0;
           c_Selection [0] := 'No';
           c_Selection [1] := 'Yes';

           If (dw_MaxNumberForEachWorksheet > 65000) Then
              dw_MaxNumberForEachWorksheet := 65000;

           If ((dw_NumberOfAcquisitions Div dw_MaxNumberForEachWorksheet) > 1000) Then
              Begin
              Writeln ('!! To many data. Can not by convert');
              Writeln ('Press any key');
              ConvertToExcel := -1;
              Exit
              End;

           (**********************************************************)
           (* Get the country code for determine the CountIf command *)
           (**********************************************************)

           GetLocaleInfo (i_LCID, 5, c_CountryCode, 11);

           Case (StrToInt (c_CountryCode)) Of
              31  : s_CountIf := 'AAntal.als';
              49  : s_CountIf := 'ZhlenWenn';
              33  : s_CountIf := 'Nb.si';
              34  : s_CountIf := 'Contar.si';
              358 : s_CountIf := 'Laske.jos';
              39  : s_CountIf := 'Conta.se';
              46  : s_CountIf := 'Antalom';
              351 : s_CountIf := 'Cont.se';
           Else
              s_CountIf := 'CountIf';
           End;

	   (*************************************)
	   (* Get the source file name and path *)
	   (*************************************)

	   s_SrcFilePath  := ExtractFilePath(s_SrcFileName);
	   s_SrcFileName  := ExtractFileName(s_SrcFileName);

	   If (s_SrcFilePath = '') Then
	      Begin
	      s_SrcFilePath := GetCurrentDir + '\';
	      End;

	   (******************************************)
	   (* Get the destination file name and path *)
	   (******************************************)

	   s_DesFilePath  := ExtractFilePath(s_DesFileName);
	   s_DesFileName  := ExtractFileName(s_DesFileName);

	   If (s_DesFilePath = '') Then
	      Begin
	      s_DesFilePath := GetCurrentDir + '\';
	      End;

	   (**************************************)
	   (* Create the temp file name and path *)
	   (**************************************)

	   s_TmpFilePath := s_SrcFilePath;
	   s_TmpFileName := s_SrcFileName;
	   s_TmpFileName := ChangeFileExt(s_TmpFileName, '.CSV');

           try
	   t_ExcelApplication := TExcelApplication.Create(Nil);
	   t_ExcelWorkbook    := TExcelWorkbook.Create   (Nil);
	   t_ExcelWorksheet   := TExcelWorksheet.Create  (Nil);
	   t_ExcelChart       := TExcelChart.Create      (Nil);

	   (*******************)
	   (* Conect to excel *)
	   (*******************)

	   t_ExcelApplication.Connect;
	   t_ExcelApplication.DisplayAlerts[i_LCID] := True;
	   t_ExcelApplication.Visible[i_LCID]:=False;

	   (***************************)
	   (* Create a new Excel file *)
	   (***************************)

	   t_ExcelWorkbook.ConnectTo(t_ExcelApplication.Workbooks.Add(TOleEnum(xlWBATWorksheet), i_LCID));
	   t_ExcelWorksheet.ConnectTo(t_ExcelApplication.Worksheets[1] as _Worksheet);
	   t_ExcelWorksheet.Name := 'in_it';
	   t_ExcelApplication.DisplayAlerts[i_LCID] := False;

	   (*****************************************)
	   (* Get the number of Worksheet to create *)
	   (*****************************************)

	   dw_NbrOfWorksheet := dw_NumberOfAcquisitions Div dw_MaxNumberForEachWorksheet;
	   If ((dw_NbrOfWorksheet * dw_MaxNumberForEachWorksheet) = dw_NumberOfAcquisitions) Then
	      Begin
	      dw_NbrOfWorksheet := dw_NbrOfWorksheet - 1;
	      End;

	   (************************)
	   (* Open the source file *)
	   (************************)

	   AssignFile (t_HandleInput, s_SrcFilePath + s_SrcFileName);
	   Reset(t_HandleInput);

	   For dw_WorksheetCounter := 0 To dw_NbrOfWorksheet Do
	      Begin
              Write (#13 + c_Wait[w_Wait]);
              w_Wait := (w_Wait + 1) Mod 4;

	      (**********************)
	      (* Open the temp file *)
	      (**********************)

	      AssignFile (t_HandleTmp, s_TmpFilePath + s_TmpFileName);
	      Rewrite    (t_HandleTmp);

	      (***********************************)
	      (* Get the number of lines to read *)
	      (***********************************)

	      If ((dw_WorksheetCounter + 1) * dw_MaxNumberForEachWorksheet > dw_NumberOfAcquisitions) Then
		 Begin
		 dw_NbrOfLines := dw_NumberOfAcquisitions - (dw_WorksheetCounter * dw_MaxNumberForEachWorksheet);
		 End
	      Else
		 Begin
		 dw_NbrOfLines := dw_MaxNumberForEachWorksheet;
		 End;

	      dw_NbrOfAcquisition := dw_NbrOfLines;

	      (***************************)
	      (* Test if the first read  *)
	      (***************************)

	      If (dw_WorksheetCounter = 0) Then
		 Begin
		 (*****************************)
		 (* Add 1 for the header line *)
		 (*****************************)

		 dw_NbrOfLines := dw_NbrOfLines + 1;
		 End;

	      For dw_ReadLineCpt := 0 To (dw_NbrOfLines - 1) Do
		 Begin
		 Readln (t_HandleInput, s_ReadString);

		 (**************************)
		 (* Test if the first line *)
		 (**************************)

		 If (dw_ReadLineCpt = 0) Then
		    Begin
		    If (dw_WorksheetCounter = 0) Then
		       Begin
		       s_Header := s_ReadString;
		       End
		    Else
		       Begin
		       Writeln (t_HandleTmp, s_Header);
		       End;
		    End;
		 Writeln (t_HandleTmp, s_ReadString);
		 End;

	      (***********************)
	      (* Close the temp file *)
	      (***********************)

	      CloseFile (t_HandleTmp);

	      (*********************************)
	      (* Import the temp file to Excel *)
	      (*********************************)

	      t_ExcelApplication.Workbooks.OpenText(s_TmpFilePath + s_TmpFileName,
						    xlWindows,
						    EmptyParam,
						    xlDelimited,
						    xlTextQualifierSingleQuote,
						    EmptyParam,
						    EmptyParam,
						    EmptyParam,
						    True,
						    EmptyParam,
						    EmptyParam,
						    EmptyParam,
						    EmptyParam,
						    EmptyParam,
						    i_LCID);

	      (****************************)
	      (* Connect to the Worksheet *)
	      (****************************)

	      t_ExcelWorksheet.ConnectTo(t_ExcelApplication.ActiveSheet as _Worksheet);

	      (**************************)
	      (* Set the Worksheet name *)
	      (**************************)

	      t_ExcelWorksheet.Name := Format ('Acquisition %d to %d',
					       [dw_WorksheetCounter * dw_MaxNumberForEachWorksheet,
						(dw_WorksheetCounter * dw_MaxNumberForEachWorksheet) + dw_NbrOfAcquisition - 1]);

	      (***************************)
	      (* Move the temp Worksheet *)
	      (***************************)

	      t_ExcelWorksheet.Move(EmptyParam, t_ExcelWorkbook.Worksheets[t_ExcelWorkbook.Worksheets.Count], i_LCID);

	      (****************************)
	      (* Connect to the Worksheet *)
	      (****************************)

	      t_ExcelWorksheet.ConnectTo(t_ExcelApplication.ActiveSheet as _Worksheet);

	      (***************************)
	      (* Set the min value titel *)
	      (***************************)

	      s_Range   := 'A' + IntToStr(dw_NbrOfLines + 4);
	      t_ExcelWorksheet.Range[s_Range, s_Range].Value := 'Min';

	      (***************************)
	      (* Set the max value titel *)
	      (***************************)

	      s_Range   := 'A' + IntToStr(dw_NbrOfLines + 5);
	      t_ExcelWorksheet.Range[s_Range, s_Range].Value := 'Max';

	      (*******************************)
	      (* Set the average value titel *)
	      (*******************************)

	      s_Range   := 'A' + IntToStr(dw_NbrOfLines + 6);
	      t_ExcelWorksheet.Range[s_Range, s_Range].Value := 'Average';

	      (***********************)
	      (* Set the min formula *)
	      (***********************)

	      For dw_Cpt := 1 To dw_NumberOfChannels Do
		 Begin
		 (************************************)
		 (* Calculate and save the min value *)
		 (************************************)

		 s_Formula    := Chr (Ord('A') + dw_Cpt) + '2:' + Chr (Ord('A') + dw_Cpt) + IntToStr (dw_NbrOfAcquisition + 1);
		 s_Range      := Chr (Ord('A') + dw_Cpt) + IntToStr(dw_NbrOfLines + 4);
		 t_ExcelWorksheet.Range[s_Range, s_Range].Formula := '=Min(' + s_Formula + ')';

		 If (d_Min [dw_Cpt - 1] > t_ExcelWorksheet.Range[s_Range, s_Range].Value) Then
		    Begin
		    d_Min [dw_Cpt - 1] := t_ExcelWorksheet.Range[s_Range, s_Range].Value;
		    End;
		 d_MinWorksheet [dw_WorksheetCounter, dw_Cpt - 1] := t_ExcelWorksheet.Range[s_Range, s_Range].Value;

		 (************************************)
		 (* Calculate and save the max value *)
		 (************************************)

		 s_Range := Chr (Ord('A') + dw_Cpt) + IntToStr(dw_NbrOfLines + 5);
		 t_ExcelWorksheet.Range[s_Range, s_Range].Formula := '=Max(' + s_Formula + ')';

		 If (d_Max [dw_Cpt - 1] < t_ExcelWorksheet.Range[s_Range, s_Range].Value) Then
		    Begin
		    d_Max [dw_Cpt - 1] := t_ExcelWorksheet.Range[s_Range, s_Range].Value;
		    End;
		 d_MaxWorksheet [dw_WorksheetCounter, dw_Cpt - 1] := t_ExcelWorksheet.Range[s_Range, s_Range].Value;

		 (****************************************)
		 (* Calculate and save the average value *)
		 (****************************************)

		 s_Range := Chr (Ord('A') + dw_Cpt) + IntToStr(dw_NbrOfLines + 6);
		 t_ExcelWorksheet.Range[s_Range, s_Range].Formula := '=Sum(' + s_Formula + ')';
		 d_Average [dw_Cpt - 1] := d_Average [dw_Cpt - 1] + t_ExcelWorksheet.Range[s_Range, s_Range].Value;
		 t_ExcelWorksheet.Range[s_Range, s_Range].Formula := '=Sum(' + s_Formula + ')/' + IntToStr(dw_NbrOfAcquisition);

		 (*************************)
		 (* Save the channel name *)
		 (*************************)

		 s_Range   := Chr (Ord('A') + dw_Cpt) + '1';
		 s_Channel [dw_Cpt - 1] := t_ExcelWorksheet.Range[s_Range, s_Range].Value;
		 s_SearchFormula [dw_WorksheetCounter, dw_Cpt - 1] := #39 + t_ExcelWorksheet.Name + #39 + '!' + s_Formula;
		 End;

	      (*****************************************)
	      (* Add a new Worksheet from type xlChart *)
	      (*****************************************)

	      t_ExcelChart.ConnectTo(t_ExcelWorkbook.Sheets.Add(EmptyParam, EmptyParam, 1, TOleEnum(xlChart), i_LCID) as _Chart);

	      (**********************)
	      (* Set the Chart name *)
	      (**********************)

	      t_ExcelChart.Name := Format ('Graph %d to %d',
					   [dw_WorksheetCounter * dw_MaxNumberForEachWorksheet,
					    (dw_WorksheetCounter * dw_MaxNumberForEachWorksheet) + dw_NbrOfAcquisition - 1]);

	      (*******************************)
	      (* Select the range to display *)
	      (*******************************)

	      Datasheet := t_ExcelWorkbook.Worksheets[t_ExcelWorksheet.Name] as _Worksheet;
	      s_Range   := Chr (Ord('A') + dw_NumberOfChannels) + IntToStr(dw_NbrOfAcquisition + 1);
	      Rnge      := Datasheet.Range['A1',s_Range];

	      (*****************)
	      (* Set the chart *)
	      (*****************)

	      t_ExcelChart.ChartWizard(Rnge,
				       TOleEnum(xlLine),
				       EmptyParam,
				       xlColumns,
				       1,
				       1,
				       True,
				       Format ('Acquisition %d to %d',
					       [dw_WorksheetCounter * dw_MaxNumberForEachWorksheet,
						(dw_WorksheetCounter * dw_MaxNumberForEachWorksheet) + dw_NbrOfAcquisition - 1]),
				       'Acquisition index',
				       'V or A',
				       EmptyParam,
				       i_LCID);
	      End;

	   (*************************)
	   (* Close the source file *)
	   (*************************)

	   CloseFile (t_HandleInput);

           (************************)
           (* Delete the temp file *)
           (************************)

           DeleteFile (s_TmpFilePath + s_TmpFileName);

	   (*****************************)
	   (* Remove the temp Worksheet *)
	   (*****************************)

	   t_ExcelWorksheet.ConnectTo(t_ExcelApplication.Worksheets['in_it'] as _Worksheet);
	   t_ExcelWorksheet.Delete;

           Writeln;
	   Write ('Make the acquisition statistic (0:No/1:Yes) : ');
	   Repeat
	      b_Choice := Byte (ReadKey) - Byte ('0');
	   Until ((b_Choice = 0) Or (b_Choice = 1));
	   Writeln (c_Selection[b_Choice]);

	   If (b_Choice = 1) Then
	      Begin
	      Writeln ('Pleas wait');
	      (**************************************)
	      (* Set the statistic for each channel *)
	      (**************************************)

	      For dw_Cpt := 1 To dw_NumberOfChannels Do
		 Begin
		 (**************************)
		 (* Create a new Worksheet *)
		 (**************************)

		 dw_FoundCpt := 0;
		 t_ExcelWorksheet.ConnectTo(t_ExcelWorkbook.Worksheets.Add(EmptyParam, EmptyParam, 1, EmptyParam, i_LCID) as _Worksheet);

		 (***********************************)
		 (* Set the Worksheet name and move *)
		 (***********************************)

		 t_ExcelWorksheet.Name := s_Channel[dw_Cpt -1] + ' statistic';
		 t_ExcelWorksheet.Move(EmptyParam, t_ExcelWorkbook.Worksheets[t_ExcelWorkbook.Worksheets.Count], i_LCID);

		 (***************************************)
		 (* Set the min, max and average result *)
		 (***************************************)

		 t_ExcelWorksheet.Range['A1', 'A1'].Value := 'Min';
		 t_ExcelWorksheet.Range['B1', 'B1'].Value := d_Min [dw_Cpt - 1];
		 t_ExcelWorksheet.Range['A2', 'A2'].Value := 'Max';
		 t_ExcelWorksheet.Range['B2', 'B2'].Value := d_Max [dw_Cpt - 1];
		 t_ExcelWorksheet.Range['A3', 'A3'].Value := 'Average';
		 t_ExcelWorksheet.Range['B3', 'B3'].Value := d_Average [dw_Cpt - 1] / dw_NumberOfAcquisitions;

		 (*****************************)
		 (* Get the min and max value *)
		 (*****************************)

		 d_TestValue := d_Min [dw_Cpt - 1] - 0.0001;
		 Repeat
                    Write (#13 + c_Wait[w_Wait]);
                    w_Wait      := (w_Wait + 1) Mod 4;
		    dw_Test     := 0;
		    d_TestValue := d_TestValue + 0.0001;
		    For dw_WorksheetCounter := 0 To dw_NbrOfWorksheet Do
		       Begin
		       (***********************************)
		       (* Test if value >= Min and <= Max *)
		       (***********************************)

		       If ((d_TestValue >= (d_MinWorksheet [dw_WorksheetCounter, dw_Cpt - 1] - 0.0001)) And
			   (d_TestValue <= (d_MaxWorksheet [dw_WorksheetCounter, dw_Cpt - 1] + 0.0001))) Then
			   Begin
			   s_Formula := Format ('=%s(%s;%7.4f)', [s_CountIf, s_SearchFormula[dw_WorksheetCounter,dw_Cpt-1], d_TestValue]);
			   t_ExcelWorksheet.Range['C1', 'C1'].FormulaArray := s_Formula;
			   dw_Test := dw_Test + t_ExcelWorksheet.Range['C1', 'C1'].Value;
			   End;
		       End;
		    t_ExcelWorksheet.Range['C1', 'C1'].FormulaArray := '';

		    (*********************)
		    (* Test if any found *)
		    (*********************)
		    If (dw_Test > 0) Then
		       Begin
		       (*******************)
		       (* Save the result *)
		       (*******************)

		       s_Range := 'B' + IntToStr(dw_FoundCpt + 7);
		       t_ExcelWorksheet.Range[s_Range, s_Range].Value := dw_Test;

		       (*************************)
		       (* Save the analog value *)
		       (*************************)

		       s_Range := 'A' + IntToStr(dw_FoundCpt + 7);
		       t_ExcelWorksheet.Range[s_Range, s_Range].Value := d_TestValue;
		       dw_FoundCpt := dw_FoundCpt + 1;
		       End;
		 Until (d_TestValue >= d_Max [dw_Cpt - 1]);

		 t_ExcelWorksheet.Range['B6', 'B6'].Value := 'Dissipation';

		 (*************************************)
		 (* Create and connect to a new chart *)
		 (*************************************)

		 ChObj := (t_ExcelWorksheet.ChartObjects(EmptyParam, i_LCID) as ChartObjects).Add(200, 50, 600, 550);
		 t_ExcelChart.ConnectTo(ChObj.Chart as _Chart);

		 (*******************************)
		 (* Select the range to display *)
		 (*******************************)

		 Datasheet := t_ExcelWorkbook.Worksheets[t_ExcelWorksheet.Name] as _Worksheet;
		 s_Range   := 'B' + IntToStr(6 + dw_FoundCpt);
		 Rnge      := Datasheet.Range['A6',s_Range];

		 (*****************)
		 (* Set the chart *)
		 (*****************)

		 t_ExcelChart.ChartWizard(Rnge,
					  TOleEnum(xl3DColumn),
					  EmptyParam,
					  xlColumns,
					  1,
					  1,
					  True,
					  s_Channel[dw_Cpt -1] + ' dissipation',
					  'V or A',
					  'Dissipation',
					  EmptyParam,
					  i_LCID);

		 End;
                 Writeln;
	      End;


	   (*********************)
	   (* Save the XLS file *)
	   (*********************)

	   t_ExcelWorkbook.SaveAs(s_DesFilePath + s_DesFileName,
				  XlFileFormat(xlWorkbookNormal),
				  EmptyParam,
				  EmptyParam,
				  EmptyParam,
				  EmptyParam,
				  xlNoChange,
				  EmptyParam,
				  EmptyParam,
				  EmptyParam,
				  EmptyParam,
				  i_LCID);

	   t_ExcelApplication.DisplayAlerts[i_LCID] := True;

	   (**************)
	   (* Disconnect *)
	   (**************)

	   bo_OK := True;

	   t_ExcelWorkbook .Disconnect;
	   t_ExcelWorksheet.Disconnect;
	   t_ExcelApplication.Disconnect;
           Except
           If (bo_OK = False) Then
              Begin
              Writeln ('!!! Excel error occur');

	      (***************)
	      (* Close Excel *)
	      (***************)

	      t_ExcelApplication.Quit;
              End;
           End;

	   If ((bo_ShowExcel = False) Or (bo_OK = False)) Then
	      Begin
	      (***************)
	      (* Close Excel *)
	      (***************)

	      t_ExcelApplication.Quit;
	      End
	   Else
	      Begin
	      (**************)
	      (* Show Excel *)
	      (**************)

	      t_ExcelApplication.Visible[i_LCID]:=True;
	      End;

	   (********************)
	   (* Disconnect Excel *)
	   (********************)

	   t_ExcelApplication.Disconnect;

	   (********************)
	   (* Free the objects *)
	   (********************)

	   t_ExcelWorkbook.Free;
	   t_ExcelWorksheet.Free;
	   t_ExcelApplication.Free;
	   ConvertToExcel := 0;
	End;
End.
