program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Windows,
  ConsoleCrt,
  DateUtils,
  pci3120;

Var
   (********************************)
   (* Console management functions *)
   (********************************)
   i_X             : Integer = 0;
   i_Y             : Integer = 0;
   i_ThreadStartY  : Integer = 0;
   i_ThreadCurentY : Integer = 0;
   h_ConsoleMutex  : THandle;
   i_InterruptCpt01  : Integer = 0;
   i_InterruptCpt02  : Integer = 0;
   h_BoardHandle01      : THandle;
   h_BoardHandle02      : THandle;




procedure v_InterruptRoutine(h_IntBoardHandle      : THandle;
                              b_FIFOOverflow    : Byte;
                              b_InterruptMask  : Byte;
                              pw_Args    : PWord;
                              dw_ArgsCount  : LongWord); cdecl;

var
  MyValues: array[0..8000] of word;
  returnvalue : Integer;
begin

    //writeln(DateTimeToStr(Now) + ' interrupt interrupt mask :' + IntToStr(b_InterruptMask) + ' arg count: ' + IntToStr (dw_ArgsCount));
    
    if((b_InterruptMask and 4) = 4) then
    begin
      writeln(DateTimeToStr(Now) + ' FIFO Overflow : arg count: ' + IntToStr(dw_ArgsCount));
    end;
    if((b_InterruptMask and 8) = 8) then
    begin
      returnvalue := integer(cardinal(l_PCI3120_ReadSequenceData(h_IntBoardHandle, dw_ArgsCount * 2, @MyValues[0])));
      if(returnvalue <> (dw_ArgsCount * 2)) then
        writeln(DateTimeToStr(Now) + ' returnvalue <> dw_ArgsCount : ' + IntToStr(returnvalue) + ' <> ' + IntToStr (dw_ArgsCount * 2));
    end;

    if(h_IntBoardHandle = h_BoardHandle01) then
      inc(i_InterruptCpt01);

    if(h_IntBoardHandle = h_BoardHandle02) then
      inc(i_InterruptCpt02);

end;

Procedure Main();
var
  boardNbr : Byte;
  returnValue : Int16;
  ChanArr: packed array[1..8] of byte;
  GainArr: packed array[1..8] of byte;
  PolArr : packed array[1..8] of byte;
  i : Integer;
  StartTime : TDateTime;

begin
	   h_ConsoleMutex :=  CreateMutex (nil, False, 'Test analog input acquisition');
	   ConsoleCrtInit;
	   ShowWindow (GetForegroundWindow, SW_MAXIMIZE);
	   Writeln;
	   Writeln;


     // Get the number of boards available
     returnValue := i_PCI3120_GetNumberOfBoards( boardNbr );
     if(returnValue = 0) then
     begin
        Writeln('Number of board found = ' + IntToStr(boardNbr));

        returnValue := i_PCI3120_OpenBoardViaIndex(0,h_BoardHandle01);
        if(returnValue =0) then
        begin
          Writeln('i_PCI3120_OpenBoardViaIndex OK');

          returnValue := i_PCI3120_OpenBoardViaIndex(1,h_BoardHandle02);

          if(returnValue <> 0) then
            Writeln('i_PCI3120_OpenBoardViaIndex error = ' + IntToStr(returnValue));

          returnValue := i_PCI3120_SetBoardIntRoutine(h_BoardHandle01,@v_InterruptRoutine);
          if(returnValue = 0) then
          begin
            Writeln('i_PCI3120_SetBoardIntRoutine OK');

            returnValue := i_PCI3120_SetBoardIntRoutine(h_BoardHandle02,@v_InterruptRoutine);
            if(returnValue <> 0) then
              Writeln('i_PCI3120_SetBoardIntRoutine error = ' + IntToStr(returnValue));

            returnValue := i_PCI3120_SetAnalogInputMode( h_BoardHandle01,PCI3120_INPUT_MODE_DIFFERENTIAL );
            if(returnValue <> 0) then
              Writeln('i_PCI3120_SetAnalogInputMode error = ' + IntToStr(returnValue));
            returnValue := i_PCI3120_SetAnalogInputMode( h_BoardHandle02,PCI3120_INPUT_MODE_DIFFERENTIAL );
            if(returnValue <> 0) then
              Writeln('i_PCI3120_SetAnalogInputMode error = ' + IntToStr(returnValue));

            for i:=0 to 7 do
            begin
              ChanArr[i] := i;
              GainArr[i] := PCI3120_GAIN_1;
              PolArr[i] := APCI3120_UNIPOLAR;
            end;

            // start the analog input sequence acquisition
          	returnValue := i_PCI3120_InitAndStartAnalogInputSequence(h_BoardHandle01,
                                                                		0,		// number of sequences to acquire (0 for continuous)
                                                                		1,		// number of sequences in one interrupt
                                                                		8,								// 8 channels
                                                                		ChanArr[1],
                                                                 		GainArr[1],
                                                                		PolArr[1],
                                                                		250,
                                                                		APCI3120_SIMPLE_MODUS,				// no delay
                                                                 		0,									          // no delay
                                                                		APCI3120_DISABLE );					  // no hardware trigger

            if( returnValue = 0) then
            begin
              Writeln('i_PCI3120_InitAndStartAnalogInputSequence OK');
            	returnValue := i_PCI3120_InitAndStartAnalogInputSequence(h_BoardHandle02,
                                                                		0,		// number of sequences to acquire (0 for continuous)
                                                                		1,		// number of sequences in one interrupt
                                                                		8,								// 8 channels
                                                                		ChanArr[1],
                                                                 		GainArr[1],
                                                                		PolArr[1],
                                                                		250,
                                                                		APCI3120_SIMPLE_MODUS,				// no delay
                                                                 		0,									          // no delay
                                                                		APCI3120_DISABLE );					  // no hardware trigger
              if(returnValue <> 0) then
                Writeln('i_PCI3120_InitAndStartAnalogInputSequence error = ' + IntToStr(returnValue));
              StartTime := Now;
              Writeln('started at :' + DateTimeToStr(StartTime));

              Writeln('Press ESC to stop the acquisition, press space to display interrupt information');


        	    (********************)
        	    (*Wait for 'ESC' hit*)
        	    (********************)
        	    while True do
              Begin
      	        If (KeyPressed = True) Then
                Begin
    	      	    If (ReadKey = Chr (27)) Then
                    break
                  else if(ReadKey = Chr(32)) then
                  begin
                    Writeln(DateTimeToStr(Now)+' Elapsed time: ' + IntToStr(SecondsBetween(StartTime,Now)) + ' sec ' + 'Interrupt Counter:' + IntToStr(i_InterruptCpt01) + ' ' + IntToStr(i_InterruptCpt02));
                  end;
      		      End;
              End;



              returnValue := i_PCI3120_StopAnalogAcquisition(h_BoardHandle01);
              if(returnValue <> 0) then
                Writeln('i_PCI3120_StopAnalogAcquisition error = ' + IntToStr(returnValue));
              returnValue := i_PCI3120_StopAnalogAcquisition(h_BoardHandle02);
              if(returnValue <> 0) then
                Writeln('i_PCI3120_StopAnalogAcquisition error = ' + IntToStr(returnValue));
            end
            else
               Writeln('i_PCI3120_InitAndStartAnalogInputSequence error = ' + IntToStr(returnValue));




            returnValue := i_PCI3120_ResetBoardIntRoutine(h_BoardHandle01);
            if(returnValue <> 0) then
              Writeln('i_PCI3120_ResetBoardIntRoutine error = ' + IntToStr(returnValue));
            returnValue := i_PCI3120_ResetBoardIntRoutine(h_BoardHandle02);
            if(returnValue <> 0) then
              Writeln('i_PCI3120_ResetBoardIntRoutine error = ' + IntToStr(returnValue));

          end
          else
            Writeln('i_PCI3120_SetBoardIntRoutine error = ' + IntToStr(returnValue));

          Writeln('');
          Writeln('');
          Writeln('Elapsed time: ' + IntToStr(SecondsBetween(StartTime,Now)) + ' sec');
          Writeln('started at: ' + DateTimeToStr(StartTime) + ' stopped at :' + DateTimeToStr(Now));
          Writeln('Interrupt Counter:' + IntToStr(i_InterruptCpt01) + ' ' + IntToStr(i_InterruptCpt02));
          
          returnValue := i_PCI3120_CloseBoard(h_BoardHandle01);
          if(returnValue <> 0) then
            Writeln('i_PCI3120_CloseBoard error = ' + IntToStr(returnValue));
          returnValue := i_PCI3120_CloseBoard(h_BoardHandle02);
          if(returnValue <> 0) then
            Writeln('i_PCI3120_CloseBoard error = ' + IntToStr(returnValue));
        end
        else
          Writeln('i_PCI3120_OpenBoardViaIndex error = ' + IntToStr(returnValue));

     end
     else
        Writeln('i_PCI3120_GetNumberOfBoards error = ' + IntToStr(returnValue));




     Writeln('Press ESC to escape the sample');
	   (********************)
	   (*Wait for 'ESC' hit*)
	   (********************)
	   while True do
     Begin
	      If (KeyPressed = True) Then
        Begin
    		  If (ReadKey = Chr (27)) Then break;
		    End;
     End;

	   (***********************)
	   (* Test if handle open *)
	   (***********************)
	   If (h_ConsoleMutex <> 0) Then
     Begin
	      (****************************)
	      (* Close the console handle *)
	      (****************************)
	      CloseHandle (h_ConsoleMutex);
     End;
	   Writeln;
	   Writeln;
end;

begin
  Main;
end.
